diff --git a/src/main/java/org/useless/seedviewer/gui/components/InfoPanel.java b/src/main/java/org/useless/seedviewer/gui/components/InfoPanel.java
new file mode 100644
index 000000000..de52b10a1
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/gui/components/InfoPanel.java
@@ -0,0 +1,166 @@
+package org.useless.seedviewer.gui.components;
+
+import net.minecraft.core.Global;
+import org.useless.seedviewer.data.Biome;
+import org.useless.seedviewer.gui.SeedViewer;
+
+import javax.swing.*;
+import javax.swing.border.LineBorder;
+import java.awt.*;
+import java.text.DateFormat;
+import java.text.SimpleDateFormat;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.List;
+
+public class InfoPanel extends JPanel {
+    private static final DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd_HH.mm.ss");
+    private final SeedViewer seedViewer;
+    public JLabel titleLabel;
+
+    public JLabel btaLabel;
+    public JLabel seedLabel;
+    public JLabel viewLabel;
+    public JLabel zoomLabel;
+    public JLabel biomeLabel;
+
+    public JLabel worldNameLabel;
+    public JLabel worldSeedLabel;
+    public JLabel worldPlayedLabel;
+
+    public List<Component> resizeList = new ArrayList<>();
+
+    public InfoPanel(SeedViewer seedViewer) {
+        this.seedViewer = seedViewer;
+        this.setLayout(null);
+        this.setBorder(new LineBorder(Color.BLACK, 1));
+    }
+
+    public void setup() {
+        final int textHeight = 15;
+
+        titleLabel = new JLabel("Information: ");
+        titleLabel.setSize(0, textHeight);
+        this.add(titleLabel);
+
+        try {
+            Class.forName("net.minecraft.core.Global");
+            btaLabel = new JLabel("BTA Version: " + Global.VERSION);
+        } catch (ClassNotFoundException e) {
+            btaLabel = new JLabel("BTA Version: Missing!");
+        }
+        add(btaLabel);
+        resizeList.add(btaLabel);
+
+        seedLabel = new JLabel("Seed: " + seedViewer.viewport.seed);
+        seedLabel.setSize(0, textHeight);
+        seedViewer.viewport.seed.addChangeListener(newValue -> seedLabel.setText("Seed: " + seedViewer.viewport.seed));
+
+        viewLabel = new JLabel(String.format("View: X:%s, Z:%s", seedViewer.viewport.viewX, seedViewer.viewport.viewZ));
+        viewLabel.setSize(0, textHeight);
+        seedViewer.viewport.viewX.addChangeListener(newValue -> viewLabel.setText(String.format("View: X:%.2f, Z:%.2f", seedViewer.viewport.viewX.get(), seedViewer.viewport.viewZ.get())));
+        seedViewer.viewport.viewX.addChangeListener(newValue -> {
+            Biome b = seedViewer.viewport.getHoveredBiome();
+            if (b == null) {
+                biomeLabel.setText("Biome: null");
+            } else {
+                biomeLabel.setText(String.format("Biome: %s", b.getName()));
+            }
+        });
+        seedViewer.viewport.viewZ.addChangeListener(newValue -> viewLabel.setText(String.format("View: X:%.2f, Z:%.2f", seedViewer.viewport.viewX.get(), seedViewer.viewport.viewZ.get())));
+        seedViewer.viewport.viewZ.addChangeListener(newValue -> {
+            Biome b = seedViewer.viewport.getHoveredBiome();
+            if (b == null) {
+                biomeLabel.setText("Biome: null");
+            } else {
+                biomeLabel.setText(String.format("Biome: %s", b.getName()));
+            }
+        });
+
+        zoomLabel = new JLabel("Zoom: " + seedViewer.viewport.zoom);
+        zoomLabel.setSize(0, textHeight);
+        seedViewer.viewport.zoom.addChangeListener(newValue -> zoomLabel.setText("Zoom: " + seedViewer.viewport.zoom));
+
+        biomeLabel = new JLabel("Biome: None");
+        biomeLabel.setSize(0, textHeight);
+
+        worldNameLabel = new JLabel();
+        worldNameLabel.setSize(0, textHeight);
+        seedViewer.viewport.world.addChangeListener(newValue -> worldNameLabel.setText("World: " + (seedViewer.viewport.world.get() == null ? "null" : seedViewer.viewport.world.get().getName())));
+        seedViewer.viewport.world.addChangeListener(newValue -> {
+            if (newValue != null) {
+                onWorldOpen();
+                seedViewer.queueResize();
+            } else {
+                onWorldClose();
+                seedViewer.queueResize();
+            }
+        });
+
+        worldSeedLabel = new JLabel();
+        worldSeedLabel.setSize(0, textHeight);
+        seedViewer.viewport.world.addChangeListener(newValue -> worldSeedLabel.setText("Seed: " + (seedViewer.viewport.world.get() == null ? "null" : seedViewer.viewport.world.get().getSeed())));
+
+        worldPlayedLabel = new JLabel();
+        worldPlayedLabel.setSize(0, textHeight);
+        seedViewer.viewport.world.addChangeListener(newValue -> worldPlayedLabel.setText("Last Played: " + (seedViewer.viewport.world.get() == null ? "?" : DateFormat.getDateTimeInstance().format(new Date(seedViewer.viewport.world.get().getLastPlayed())))));
+
+        addManaged(seedLabel);
+        addManaged(viewLabel);
+        addManaged(zoomLabel);
+        addManaged(biomeLabel);
+        addManaged(worldNameLabel);
+        addManaged(worldSeedLabel);
+        addManaged(worldPlayedLabel);
+
+        if (seedViewer.viewport.world.get() == null) {
+            onWorldClose();
+        } else {
+            onWorldOpen();
+        }
+    }
+
+    public void addManaged(Component c) {
+        add(c);
+        resizeList.add(c);
+    }
+
+    public void onWorldOpen() {
+        worldNameLabel.setEnabled(true);
+        worldNameLabel.setVisible(true);
+        worldSeedLabel.setEnabled(true);
+        worldSeedLabel.setVisible(true);
+        worldPlayedLabel.setEnabled(true);
+        worldPlayedLabel.setVisible(true);
+
+        seedLabel.setEnabled(false);
+        seedLabel.setVisible(false);
+    }
+
+    public void onWorldClose() {
+        worldNameLabel.setEnabled(false);
+        worldNameLabel.setVisible(false);
+        worldSeedLabel.setEnabled(false);
+        worldSeedLabel.setVisible(false);
+        worldPlayedLabel.setEnabled(false);
+        worldPlayedLabel.setVisible(false);
+
+        seedLabel.setEnabled(true);
+        seedLabel.setVisible(true);
+    }
+
+    public void onResize(Rectangle newDimensions) {
+        setBounds(newDimensions.x, newDimensions.y, newDimensions.width, newDimensions.height);
+
+        final int edgePad = 5;
+        final int elementPad = 2;
+        titleLabel.setBounds(edgePad, edgePad, newDimensions.width - edgePad * 2, titleLabel.getHeight());
+
+        int lastY = titleLabel.getY() + titleLabel.getHeight() + edgePad * 2;
+        for (Component c : resizeList) {
+            if (!c.isVisible()) continue;
+            c.setBounds(edgePad, lastY, newDimensions.width - edgePad * 2, c.getHeight());
+            lastY += c.getHeight() + elementPad;
+        }
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/gui/components/InputPanel.java b/src/main/java/org/useless/seedviewer/gui/components/InputPanel.java
new file mode 100644
index 000000000..ab3c9e65a
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/gui/components/InputPanel.java
@@ -0,0 +1,250 @@
+package org.useless.seedviewer.gui.components;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
+import org.slf4j.Logger;
+import org.useless.seedviewer.gui.SeedViewer;
+
+import javax.imageio.ImageIO;
+import javax.swing.*;
+import javax.swing.border.LineBorder;
+import javax.swing.filechooser.FileNameExtensionFilter;
+import java.awt.*;
+import java.awt.event.ActionEvent;
+import java.awt.image.BufferedImage;
+import java.io.File;
+import java.io.IOException;
+import java.text.DateFormat;
+import java.text.SimpleDateFormat;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.List;
+
+public class InputPanel extends JPanel {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static final DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd_HH.mm.ss");
+    private final SeedViewer seedViewer;
+
+    public JLabel titleLabel;
+
+    public JCheckBox slimeChunksBox;
+    public JCheckBox showBordersBox;
+    public JCheckBox showBiomesBox;
+    public JCheckBox showTerrainBox;
+    public JCheckBox showCrosshairBox;
+    public JTextField seedInputBox;
+    public JButton screenshot;
+    public JButton openWorld;
+    public JButton closeWorld;
+
+    private final List<Component> resizeList = new ArrayList<>();
+
+    public InputPanel(SeedViewer seedViewer) {
+        this.seedViewer = seedViewer;
+        this.setLayout(null); // using no layout managers
+        this.setBorder(new LineBorder(Color.BLACK, 1));
+    }
+
+    public void setup() {
+        final int boxHeight = 15;
+        final int textHeight = 15;
+        final int textFieldHeight = 30;
+        final int button = 30;
+
+        titleLabel = new JLabel("User Controls: ");
+        titleLabel.setSize(0, textHeight);
+        this.add(titleLabel);
+
+        slimeChunksBox = new JCheckBox("Slime Chunks");
+        slimeChunksBox.setSize(0, boxHeight);
+        slimeChunksBox.setSelected(seedViewer.viewport.showSlimeChunks.get());
+        slimeChunksBox.addChangeListener(e -> seedViewer.viewport.showSlimeChunks.set(slimeChunksBox.isSelected()));
+        slimeChunksBox.addChangeListener(e -> seedViewer.viewport.repaint());
+
+        showBordersBox = new JCheckBox("Chunk Borders");
+        showBordersBox.setSize(0, boxHeight);
+        showBordersBox.setSelected(seedViewer.viewport.showChunkBorders.get());
+        showBordersBox.addChangeListener(e -> seedViewer.viewport.showChunkBorders.set(showBordersBox.isSelected()));
+        showBordersBox.addChangeListener(e -> seedViewer.viewport.repaint());
+
+        showBiomesBox = new JCheckBox("Show Biomes");
+        showBiomesBox.setSize(0, boxHeight);
+        showBiomesBox.setSelected(seedViewer.viewport.showBiomes.get());
+        showBiomesBox.addChangeListener(e -> seedViewer.viewport.showBiomes.set(showBiomesBox.isSelected()));
+        showBiomesBox.addChangeListener(e -> seedViewer.viewport.repaint());
+
+        showTerrainBox = new JCheckBox("Show Terrain");
+        showTerrainBox.setSize(0, boxHeight);
+        showTerrainBox.setSelected(seedViewer.viewport.showTerrain.get());
+        showTerrainBox.addChangeListener(e -> seedViewer.viewport.showTerrain.set(showTerrainBox.isSelected()));
+        showTerrainBox.addChangeListener(e -> seedViewer.viewport.repaint());
+
+        showCrosshairBox = new JCheckBox("Enable Cross-hair");
+        showCrosshairBox.setSize(0, boxHeight);
+        showCrosshairBox.setSelected(seedViewer.viewport.showCrosshair.get());
+        showCrosshairBox.addChangeListener(e -> seedViewer.viewport.showCrosshair.set(showCrosshairBox.isSelected()));
+        showCrosshairBox.addChangeListener(e -> seedViewer.viewport.repaint());
+
+        addManaged(slimeChunksBox);
+        addManaged(showBordersBox);
+        addManaged(showBiomesBox);
+        addManaged(showTerrainBox);
+        addManaged(showCrosshairBox);
+
+        seedInputBox = new JTextField(seedViewer.viewport.seed.toString());
+        seedInputBox.setSize(0, textFieldHeight);
+        seedInputBox.addActionListener(new AbstractAction() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                long boxSeed;
+                try {
+                    boxSeed = Long.parseLong(seedInputBox.getText());
+                } catch (NumberFormatException exception) {
+                    boxSeed = seedInputBox.getText().hashCode();
+                }
+                if (boxSeed != seedViewer.viewport.seed.get()) {
+                    seedViewer.viewport.setSeed(boxSeed);
+                }
+            }
+        });
+        addManaged(seedInputBox);
+
+        screenshot = new JButton("Save Screenshot");
+        screenshot.setSize(0, button);
+        screenshot.addActionListener(new AbstractAction() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                final File screenShotFolder = new File(Global.accessor.getMinecraftDir(), "screenshots");
+                screenShotFolder.mkdirs();
+                JFileChooser screenShotSelect = new JFileChooser(screenShotFolder);
+
+                String name = "Seed-Viewer-" + dateFormat.format(new Date());
+                File defaultFile;
+                int k = 1;
+                while ((defaultFile = new File(screenShotFolder, name + (k != 1 ? "_" + k : "") + ".png")).exists()) {
+                    k++;
+                }
+
+                screenShotSelect.setSelectedFile(defaultFile);
+
+                screenShotSelect.setDialogTitle("Save Screenshot");
+                screenShotSelect.setApproveButtonText("Save");
+                screenShotSelect.setFileSelectionMode(JFileChooser.FILES_ONLY);
+                screenShotSelect.addChoosableFileFilter(new FileNameExtensionFilter("Image (*.png)", "png"));
+
+                screenShotSelect.setAcceptAllFileFilterUsed(true);
+
+                int result = screenShotSelect.showOpenDialog(seedViewer);
+                if (result == JFileChooser.APPROVE_OPTION) {
+                    File destFile = screenShotSelect.getSelectedFile();
+                    LOGGER.info("Selected file: {}", destFile.getAbsolutePath());
+
+                    BufferedImage viewportImage = new BufferedImage(seedViewer.viewport.getWidth(), seedViewer.viewport.getHeight(), BufferedImage.TYPE_INT_ARGB);
+                    Graphics g = viewportImage.getGraphics();
+                    seedViewer.viewport.paintToGraphics(g);
+                    g.dispose();
+
+                    LOGGER.info("Attempting to save screenshot to '{}'!", destFile);
+                    try {
+                        destFile.createNewFile();
+                        String[] dotSep = destFile.getName().split("\\.");
+                        ImageIO.write(viewportImage, dotSep[dotSep.length - 1], destFile);
+                    } catch (IOException ex) {
+                        LOGGER.error("Failed to save screenshot to '{}'!", destFile, ex);
+                    }
+
+                }
+            }
+        });
+        addManaged(screenshot);
+
+        openWorld = new JButton("Open World");
+        openWorld.setSize(0, button);
+        openWorld.addActionListener(new AbstractAction() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                JFileChooser worldSelector = new JFileChooser(new File(Global.accessor.getMinecraftDir(), "saves/"));
+
+                worldSelector.setDialogTitle("Select World");
+                worldSelector.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
+                worldSelector.setAcceptAllFileFilterUsed(false);
+
+                int result = worldSelector.showOpenDialog(seedViewer);
+                if (result == JFileChooser.APPROVE_OPTION) {
+                    File selectedFile = worldSelector.getSelectedFile();
+                    LOGGER.info("Selected file: {}", selectedFile.getAbsolutePath());
+                    seedViewer.viewport.setWorld(selectedFile);
+
+                } else {
+                    seedViewer.viewport.setWorld(null);
+                }
+            }
+        });
+        seedViewer.viewport.world.addChangeListener(newValue -> {
+            if (newValue != null) {
+                onWorldOpen();
+                seedViewer.queueResize();
+            } else {
+                onWorldClose();
+                seedViewer.queueResize();
+            }
+        });
+        addManaged(openWorld);
+
+        closeWorld = new JButton("Close World");
+        closeWorld.setSize(0, button);
+        closeWorld.addActionListener(new AbstractAction() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                seedViewer.viewport.setWorld(null);
+            }
+        });
+        addManaged(closeWorld);
+
+        if (seedViewer.viewport.world.get() == null) {
+            onWorldClose();
+        } else {
+            onWorldOpen();
+        }
+    }
+
+    public void onWorldOpen() {
+        seedInputBox.setEnabled(false);
+        seedInputBox.setVisible(false);
+
+        closeWorld.setEnabled(true);
+        closeWorld.setVisible(true);
+        showTerrainBox.setEnabled(true);
+        showTerrainBox.setVisible(true);
+    }
+
+    public void onWorldClose() {
+        seedInputBox.setEnabled(true);
+        seedInputBox.setVisible(true);
+
+        closeWorld.setEnabled(false);
+        closeWorld.setVisible(false);
+        showTerrainBox.setEnabled(false);
+        showTerrainBox.setVisible(false);
+    }
+
+    public void addManaged(Component c) {
+        add(c);
+        resizeList.add(c);
+    }
+
+    public void onResize(Rectangle newDimensions) {
+        setBounds(newDimensions.x, newDimensions.y, newDimensions.width, newDimensions.height);
+
+        final int edgePad = 5;
+        final int elementPad = 2;
+        titleLabel.setBounds(edgePad, edgePad, newDimensions.width - edgePad * 2, titleLabel.getHeight());
+
+        int lastY = titleLabel.getY() + titleLabel.getHeight() + edgePad * 2;
+        for (Component c : resizeList) {
+            if (!c.isVisible()) continue;
+            c.setBounds(edgePad, lastY, newDimensions.width - edgePad * 2, c.getHeight());
+            lastY += c.getHeight() + elementPad;
+        }
+    }
+}
